<?php
/**
*
* @package Sidebar
* @copyright (c) 01.01.2020 kaptangula
* @license http://opensource.org/licenses/gpl-2.0.php GNU General Public License v2
*
*/

namespace kaptangula\sidebar\acp;

class sidebar_module
{
	var $u_action;

	function main($id, $mode)
	{
		global $db, $user, $auth, $template, $cache, $request, $phpbb_container;
		global $config, $phpbb_root_path, $phpbb_admin_path, $phpEx;

		$config_text = $phpbb_container->get('config_text');

		$user->add_lang('acp/common');
		$user->add_lang_ext('kaptangula/sidebar', 'acp/info_acp_sidebar');
		$this->tpl_name = 'acp_sidebar';
		$this->page_title = $user->lang['SIDEBAR_SIDEBAR_MOD'];
		add_form_key('acp_sidebar');
		// Version Check
		$this->config['SIDEBAR_VERSION'] = (isset($this->config['SIDEBAR_VERSION'])) ? $this->config['SIDEBAR_VERSION'] : '2.1.3';

		if ($request->is_set_post('submit'))
		{
			if (!check_form_key('acp_sidebar'))
			{
				trigger_error('FORM_INVALID');
			}

			$config->set('enable_sideblock', $request->variable('enable_sideblock', 0));
			$config->set('viewtopic_sideblock', $request->variable('viewtopic_sideblock', true));
			$config->set('ad_type', $request->variable('ad_type', true));
			$config->set('width_ratio', $request->variable('width_ratio', true));
			$config->set('statistics_side', $request->variable('statistics_side', 0));	
			$config->set('search_side', $request->variable('search_side', 0));	
			$config->set('birthdays_side', $request->variable('birthdays_side', 0));
			$config->set('display_top_users', $request->variable('display_top_users', 0));
			$config->set('topusers_display_nmb', $request->variable('topusers_display_nmb', ''));
			$config->set('avatar_re_size', $request->variable('avatar_re_size', ''));
			$config->set('link_side', $request->variable('link_side', 0));	
			$config->set('sidebar_texta', $request->variable('sidebar_texta', 0));
			$config->set('sidebar_textb', $request->variable('sidebar_textb', '', true));
			$config->set('sidebar_text', $request->variable('sidebar_text', '', true));
											
			$config->set('link_side_url', $request->variable('link_side_url', '', true));										
			$config->set('link_side_urlb', $request->variable('link_side_urlb', '', true));
			$config->set('sidebar_width', $request->variable('sidebar_width', 0));
 			$config->set('adsense_side', $request->variable('adsense_side', 0));
			$config_text->set('SIDEBAR_VERSION', $request->variable('SIDEBAR_VERSION', '', true));

			meta_refresh(3, $this->u_action);
			trigger_error($user->lang['AD_SAVED'] . adm_back_link($this->u_action));
		}

		$template->assign_vars(array(
			'ENABLE_SIDEBLOCK'		=> $config['enable_sideblock'],
			'VIEWTOPIC_SIDEBLOCK'				=> $config['viewtopic_sideblock'],
			'SIDEBAR_TEXTA'				=> $config['sidebar_texta'],
			'TYPE'					=> $config['ad_type'],
			'WIDTH_RATIO'			=> $config['width_ratio'],
			'STATISTICS_SIDE'		=> $config['statistics_side'],
			'SEARCH_SIDE'			=> $config['search_side'],
			'BIRTHDAYS_SIDE'		=> $config['birthdays_side'],
			'DISPLAY_TOP_USERS'		=> $config['display_top_users'],
			'TOPUSERS_DISPLAY_NMB'	=> $config['topusers_display_nmb'],
			'TOP_AVATAR_SIZE'		=> $config['avatar_re_size'],																		
			'LINK_SIDE'				=> $config['link_side'],																		
			'LINK_SIDE_URL'			=> $config['link_side_url'],	
			'LINK_SIDE_URLb'		=> $config['link_side_urlb'],							
			'SIDEBAR_WIDTH'			=> $config['sidebar_width'],
			'ADSENSE_SIDE'			=> $config['adsense_side'],
			'SIDEBAR_TEXTB'			=> $config['sidebar_textb'],
			'SIDEBAR_TEXT'			=> $config['sidebar_text'],
			'SIDEBAR_VERSION'		=> $this->config['SIDEBAR_VERSION'],
			'S_VERSION_UP_TO_DATE'	=> $this->sidebar_version_compare($this->config['SIDEBAR_VERSION']),
			'U_ACTION'				=> $this->u_action,
		));
	}
	/**
	* Obtains the latest version information
	* @param string    $current_version    version information
	* @param int       $ttl             Cache version information for $ttl seconds. Defaults to 86400 (24 hours).
	*
	* @return bool       false on failure.
	**/
	function sidebar_version_compare($current_version = '', $version_up_to_date = true, $ttl = 86400)
	{
		global $cache, $template;

		$info = $cache->get('sidebar_versioncheck');

		if ($info === false)
		{
			$errstr = '';
			$errno = 0;

			$info = get_remote_file('http://www.aligunel.net/', '/sidebar', 'sidebar_ext.txt', $errstr, $errno);
			if ($info === false)
			{
				$template->assign_var('S_VERSIONCHECK_FAIL', true);
				$cache->destroy('sidebar_versioncheck');
			}
		}
		else
		{
			$cache->put('sidebar_versioncheck', $info, $ttl);
			$latest_version_info = explode("\n", $info);

			$latest_version = strtolower(trim($latest_version_info[0]));
			$current_version = strtolower(trim($current_version));
			$version_up_to_date = version_compare($current_version, $latest_version, '<') ? false : true;

			$template->assign_vars(array(
				'U_VERSIONCHECK'	=> ($version_up_to_date) ? false : $latest_version_info[1],
				'S_VERSIONOLD'		=> $current_version,
				'S_VERSIONNEW'		=> ($version_up_to_date) ? false : $latest_version_info[0],
			));
		}
		return $version_up_to_date;
	}
}